
from stem.descriptor.remote import DescriptorDownloader
from stem.version import Version
from tor_controller import set_socks_proxy

def iMain():
    set_socks_proxy()
    downloader = DescriptorDownloader()
    count, with_contact = 0, 0
    elts = downloader.get_server_descriptors()
    print(f"Checking for outdated relays len server_descriptors={len(list(elts))}...")
    print("")
    
    for desc in elts:
      if desc.tor_version < Version('0.2.3.0'):
        count += 1
    
        if desc.contact:
          print('  %-15s %s' % (desc.tor_version, desc.contact.decode("utf-8", "replace")))
          with_contact += 1
    
    print("")
    print("%i outdated relays found, %i had contact information" % (count, with_contact))
    # http://vt5hknv6sblkgf22.onion/tutorials/examples/outdated_relays.htmlhttp://vt5hknv6sblkgf22.onion/tutorials/examples/outdated_relays.html
    return 0

if __name__ == '__main__':
    sys.exit(    iMain())
